library ieee;
use ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.numeric_std.all;

entity testbench is
end testbench;

ARCHITECTURE behavioral of testbench is
   --Input and Output definitions.
   signal clk : std_logic := '0';
   signal rst : std_logic := '1';
   signal limit : std_logic_vector(9 downto 0);
   signal fibo_series : std_logic_vector(9 downto 0);
   -- Clock period definitions
   constant clk_period : time := 2 ns;
BEGIN
   -- Instantiate the Unit Under Test (UUT)
   uut: entity work.fibonacci PORT MAP (
          clk => clk,
          rst => rst,
          limit => limit,
          fibo_series => fibo_series
        );
   -- Clock process definitions
   clk_process :process
   begin
    clk <= '0';
    wait for clk_period/2;
    clk <= '1';
    wait for clk_period/2;
   end process;
   
   testing: process
   begin
    rst <= '0';
    limit <= std_logic_vector(to_unsigned(233, limit'length));
    wait for clk_period;
   end process;
END;